#include <iostream>
#include "AlberoBinario.h"

using namespace std;

void initAlbero(Albero& a) {
	a = NULL;
}

void createRoot(Albero& a, int info) {
NodoAlbero* root = new NodoAlbero();
	root->father = NULL;
	root->left = NULL;
	root->right= NULL;
	root->info = info;
	a = root;
}

int isEmpty(Albero& a) {
	return (a == NULL);
}

NodoAlbero* getFather(NodoAlbero* x) {
	return x->father;
}

NodoAlbero* getLeft(NodoAlbero* x) {
	return x->left;
}

NodoAlbero* getRight(NodoAlbero* x) {
	return x->right;
}

NodoAlbero* insert(NodoAlbero* x, int info) {
	if (x->right==NULL) {
		NodoAlbero* node = new NodoAlbero();
		node->father = x;
		node->left = NULL;
		node->right = NULL;
		node->info = info;
		x->right = node;
		return node;
	}
	else if (x->left==NULL) {
		NodoAlbero* node = new NodoAlbero();
		node->father = x;
		node->left = NULL;
		node->right = NULL;
		node->info = info;
		x->left = node;
		return node;
	}
	else
		return NULL;
}

void del(NodoAlbero* x) {
	if (x->left==NULL && x->right==NULL) {
		(x->father)->left = NULL;
		(x->father)->right =NULL;
		delete(x);
	}
}

void deallocaAlbero(Albero& a) {
	if( a!=NULL ) {
    		deallocaAlbero(a->left);
    		deallocaAlbero(a->right);
  	}
  	delete(a);
}

/* questo metodo ausiliario ritorna true se il nodo e' una foglia, false altrimenti */
bool eFoglia(NodoAlbero* n){
  return (!(n->right) && !(n->left));
}

int eliminaFoglie(Albero& a){
  if (a){
      if(eFoglia(a)){
	delete a;
	a = 0;
	return 1;
      }
      else
	return eliminaFoglie(a->left) + eliminaFoglie(a->right);
  }
  return 0;
}

bool cercaFoglia(Albero& a, int el, bool& foglia){
  if(!a)
    return false;
  
  bool trovato;
  
  //cerco subito piu' in basso
  if(el > a->info)
    trovato = cercaFoglia(a->right, el, foglia);
  else
    trovato = cercaFoglia(a->left, el, foglia);
  
  if(!trovato){ //se piu' in basso non l'ho trovato...
    if(a->info == el){ //...perche' e' proprio il nodo corrente...
      trovato = true;
      foglia = eFoglia(a); //verifico se e' una foglia
    }
  }
  return trovato;
}

bool cercaNodo(Albero& a, int el, bool& nodo){
  if(!a)
    return false;
    
    if(a->info == el){ //se l'elemento corrente e' pari a el...
      nodo = (!eFoglia(a)); //verifico se e' un nodo...
      return true; //esco con risultato positivo visto che e' inutile procedere verso il basso
    }
    else //se non l'ho trovato cerco piu' in basso
      if(el > a->info)
	return cercaNodo(a->right, el, nodo);
      else
	return cercaNodo(a->left, el, nodo);
}

bool uguale(Albero& a1, Albero& a2){
  if(a1 == a2) //se i puntatori alle radici coincidono, gli albero sono uguali NB vale anche nel caso gli alberi siano vuoti
    return true;
  if((!a1 || !a2) && (a1 || a2)) //se solo una delle radici e' 0 i due alberi non sono uguali
    return false;
  
  //se nessuna delle radici e' 0
  if(a1->info != a2->info) //se i due elementi puntati dalle radici sono doversi allora anche gli alberi sono diversi
    return false;
  
  //dunque abbiamo due alberi non vuoti e contenenti elementi di uguale valore della radice. Bisogna controllare che l'uguaglianza dei sottoalberi
  return uguale(a1->left, a2->left) && uguale(a1->right, a2->right);
}
  
